/*
 * SPDX-FileCopyrightText: 2010-2022 Espressif Systems (Shanghai) CO LTD
 *
 * SPDX-License-Identifier: CC0-1.0
 */

#define LV_CONF_INCLUDE_SIMPLE 1
#include "lv_conf.h"

/* 然后包含 lvgl.h */
#include "lvgl.h"

#include <stdio.h>
#include <inttypes.h>
#include "sdkconfig.h"
#include "freertos/FreeRTOS.h"
#include "freertos/task.h"
#include "freertos/timers.h"
#include "esp_chip_info.h"
#include "esp_flash.h"
#include "esp_system.h"

#include "esp_log.h"

#include "spi.h"

#include "lcd.h"

#include "esp_timer.h"

#include "lv_port_disp.h"

#include "lv_apps/helloworld/lv_helloworld.h"

static const char *TAG = "SYS";

// TimerHandle_t periodic_timer = NULL;

// 定时器回调函数（在定时器服务任务中执行）
// void periodic_timer_callback(TimerHandle_t xTimer)
// {
//     // printf("每秒执行一次的函数\n");
//     //  在这里执行你的周期性任务
//     //  注意：此回调函数应尽快返回，避免阻塞定时器服务任务

//     lcd_one_second_task();
// }

// 自定义 tick 获取函数
static uint32_t custom_tick_get(void)
{
    // 返回从启动到现在的毫秒数
    return (uint32_t)(esp_timer_get_time() / 1000);
}

/**
 * Basic example to create a "Hello world" label
 */


// static void btn_event_cb(lv_event_t * e)
// {
//     lv_event_code_t code = lv_event_get_code(e);
//     lv_obj_t * btn = lv_event_get_target(e);
//     if(code == LV_EVENT_CLICKED) {
//         static uint8_t cnt = 0;
//         cnt++;

//         /*Get the first child of the button which is the label and change its text*/
//         lv_obj_t * label = lv_obj_get_child(btn, 0);
//         lv_label_set_text_fmt(label, "Button: %d", cnt);
//     }
// }

// /**
//  * Create a button with a label and react on click event.
//  */
// void lv_example_get_started_2(void)
// {
//     lv_obj_t * btn = lv_button_create(lv_screen_active());     /*Add a button the current screen*/
//     lv_obj_set_pos(btn, 10, 10);                            /*Set its position*/
//     lv_obj_set_size(btn, 120, 50);                          /*Set its size*/
//     lv_obj_add_event_cb(btn, btn_event_cb, LV_EVENT_ALL, NULL);           /*Assign a callback to the button*/

//     lv_obj_t * label = lv_label_create(btn);          /*Add a label to the button*/
//     lv_label_set_text(label, "Button");                     /*Set the labels text*/
//     lv_obj_center(label);
// }

void app_main(void)
{
    ESP_LOGI(TAG,"Hello world!");

    /* Print chip information */
    esp_chip_info_t chip_info;
    uint32_t flash_size;
    esp_chip_info(&chip_info);
    ESP_LOGI(TAG,"This is %s chip with %d CPU core(s), %s%s%s%s, ",
           CONFIG_IDF_TARGET,
           chip_info.cores,
           (chip_info.features & CHIP_FEATURE_WIFI_BGN) ? "WiFi/" : "",
           (chip_info.features & CHIP_FEATURE_BT) ? "BT" : "",
           (chip_info.features & CHIP_FEATURE_BLE) ? "BLE" : "",
           (chip_info.features & CHIP_FEATURE_IEEE802154) ? ", 802.15.4 (Zigbee/Thread)" : "");

    unsigned major_rev = chip_info.revision / 100;
    unsigned minor_rev = chip_info.revision % 100;
    ESP_LOGI(TAG,"silicon revision v%d.%d, ", major_rev, minor_rev);
    if (esp_flash_get_size(NULL, &flash_size) != ESP_OK)
    {
        ESP_LOGI(TAG,"Get flash size failed");
        return;
    }

    ESP_LOGI(TAG,"%" PRIu32 "MB %s flash", flash_size / (uint32_t)(1024 * 1024),
           (chip_info.features & CHIP_FEATURE_EMB_FLASH) ? "embedded" : "external");

    ESP_LOGI(TAG,"Minimum free heap size: %" PRIu32 " bytes", esp_get_minimum_free_heap_size());

    ESP_LOGI(TAG,"sizeof(int) ==%d", sizeof(int));
    ESP_LOGI(TAG,"LVGL version: %s", lv_version_info());
    ESP_LOGI(TAG,"LVGL memory size: %u bytes", LV_MEM_SIZE);
    ESP_LOGI(TAG,"LVGL color depth: %d bits", LV_COLOR_DEPTH);

    spi_init();
    lcd_init();

    lv_init();
    lv_tick_set_cb(custom_tick_get);
    lv_port_disp_init();

    lv_example_get_started_1();
    
    while (1)
    {

        // lcd_clear_buf(rand());
        // lcd_send_full_buf();
        // t = custom_tick_get();
        // ESP_LOGI(TAG, "NOW is%lu", t);

        lv_task_handler();
        vTaskDelay(1); // 必须让出CPU
    }
}
